cascading.flow.hadoop

## Class MapReduceFlowStep

- java.lang.Object
- - cascading.flow.planner.BaseFlowStep<org.apache.hadoop.mapred.JobConf>
  - - cascading.flow.hadoop.HadoopFlowStep
    - - cascading.flow.hadoop.MapReduceFlowStep

All Implemented Interfaces:
  FlowStep<org.apache.hadoop.mapred.JobConf>, ProcessModel, ProcessLogger, java.io.Serializable

    public class MapReduceFlowStep
    extends HadoopFlowStep

Class MapReduceFlowStep wraps a `JobConf` and allows it to be executed as a `Flow`.

See Also:
  Serialized Form

### Field Summary

Fields
`static java.lang.String` `MAP`
`static java.lang.String` `REDUCE`
`static java.lang.String` `SHUFFLE`

### Fields inherited from class cascading.flow.planner.BaseFlowStep

`elementGraph, flowNodeGraph, flowStepStats, sinks, sources, tempSink`

### Fields inherited from interface cascading.flow.FlowStep

`CASCADING_FLOW_STEP_ID`

### Fields inherited from interface cascading.util.ProcessLogger

`NULL`

### Constructor Summary

Constructors
`` `MapReduceFlowStep(HadoopFlow flow, org.apache.hadoop.mapred.JobConf jobConf)`
`protected` `MapReduceFlowStep(HadoopFlow flow, java.lang.String stepName, org.apache.hadoop.mapred.JobConf jobConf, Tap sink)`

### Method Summary

Methods
`protected ElementDirectedGraph` `createElementDirectedGraph()`
`protected FlowNodeGraph` `createFlowNodeGraph(java.util.List<ElementGraph> elementGraphs)`
`org.apache.hadoop.mapred.JobConf` `createInitializedConfig(FlowProcess<org.apache.hadoop.mapred.JobConf> flowProcess, org.apache.hadoop.mapred.JobConf parentConfig)` Public for testing.
`protected Pipe` `createMapOperation()`
`protected Pipe` `createReduceOperation()`
`protected Pipe` `createShuffleOperation()`
`ElementGraph` `getElementGraph()`
`FlowNodeGraph` `getFlowNodeGraph()`
`protected org.apache.hadoop.mapred.JobConf` `getJobConf()`

### Methods inherited from class cascading.flow.hadoop.HadoopFlowStep

`clean, cleanIntermediateData, createFlowStepJob, getConfigAsProperties, initFromSink, initFromSources, initFromTraps, isHadoopLocalMode`

### Methods inherited from class cascading.flow.planner.BaseFlowStep

`addAllGroups, addGroup, addGroups, addListener, addProcessAnnotation, addProcessAnnotation, addSink, addSinks, addSource, addSources, clean, commitSinks, configure, containsPipeNamed, createClientState, equals, fireOnCompleted, fireOnRunning, fireOnStarting, fireOnStopping, fireOnThrowable, getAllAccumulatedSources, getAllOperations, getAllStreamedSources, getAnnotations, getConfig, getCreateFlowStepJob, getFlow, getFlowID, getFlowName, getFlowStepDescriptor, getFlowStepJob, getFlowStepStats, getGroup, getGroups, getID, getName, getNextFlowElement, getNextScope, getNodeDisplayName, getNumFlowNodes, getOrdinal, getPreviousScopes, getProcessAnnotations, getSink, getSinkElements, getSinkName, getSinkTaps, getSinkWith, getSourceElements, getSourceName, getSourceTaps, getSourceWith, getStepDisplayName, getStepDisplayName, getSubmitPriority, getTrap, getTrapMap, getTraps, hashCode, hasListeners, initConfFromNodeConfigDef, initConfFromStepConfigDef, isDebugEnabled, isInfoEnabled, logDebug, logError, logError, logInfo, logWarn, logWarn, logWarn, prepareResources, removeListener, rollbackSinks, setConfig, setFlow, setFlowName, setFlowStepDescriptor, setFlowStepStats, setName, setOrdinal, setSubmitPriority, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### MAP

    public static final java.lang.String MAP

See Also:
  Constant Field Values

#### SHUFFLE

    public static final java.lang.String SHUFFLE

See Also:
  Constant Field Values

#### REDUCE

    public static final java.lang.String REDUCE

See Also:
  Constant Field Values

### Constructor Detail

#### MapReduceFlowStep

    public MapReduceFlowStep(HadoopFlow flow,
                     org.apache.hadoop.mapred.JobConf jobConf)

#### MapReduceFlowStep

    protected MapReduceFlowStep(HadoopFlow flow,
                     java.lang.String stepName,
                     org.apache.hadoop.mapred.JobConf jobConf,
                     Tap sink)

### Method Detail

#### getJobConf

    protected org.apache.hadoop.mapred.JobConf getJobConf()

#### getElementGraph

    public ElementGraph getElementGraph()

Specified by:
  `getElementGraph` in interface `ProcessModel`
Overrides:
  `getElementGraph` in class `BaseFlowStep<org.apache.hadoop.mapred.JobConf>`

#### getFlowNodeGraph

    public FlowNodeGraph getFlowNodeGraph()

Specified by:
  `getFlowNodeGraph` in interface `FlowStep<org.apache.hadoop.mapred.JobConf>`
Overrides:
  `getFlowNodeGraph` in class `BaseFlowStep<org.apache.hadoop.mapred.JobConf>`

#### createInitializedConfig

    public org.apache.hadoop.mapred.JobConf createInitializedConfig(FlowProcess<org.apache.hadoop.mapred.JobConf> flowProcess,
                                                           org.apache.hadoop.mapred.JobConf parentConfig)

Description copied from class: `BaseFlowStep`
Public for testing.

Overrides:
  `createInitializedConfig` in class `HadoopFlowStep`
Returns:

#### createElementDirectedGraph

    protected ElementDirectedGraph createElementDirectedGraph()

#### createMapOperation

    protected Pipe createMapOperation()

#### createShuffleOperation

    protected Pipe createShuffleOperation()

#### createReduceOperation

    protected Pipe createReduceOperation()

#### createFlowNodeGraph

    protected FlowNodeGraph createFlowNodeGraph(java.util.List<ElementGraph> elementGraphs)